import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import mqtt from 'mqtt';
import getMqttTopic from './get_mqtt_topic';
import { subscribeAdapterNotInitialized, subscribeAdapterAlreadyInitialized } from './constants';
var qos = 1;

var createClientAdapter = function createClientAdapter(_ref) {
  var url = _ref.url,
      appId = _ref.appId,
      onEvent = _ref.onEvent;
  var client;
  var isInitialized;
  return {
    init: function () {
      var _init = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!isInitialized) {
                  _context.next = 2;
                  break;
                }

                throw new Error(subscribeAdapterAlreadyInitialized);

              case 2:
                _context.next = 4;
                return new Promise(function (resolve, reject) {
                  client = mqtt.connect(url);
                  client.on('connect', function () {
                    isInitialized = true;
                    resolve();
                  });
                  client.on('error', function (err) {
                    reject(err);
                  });
                  client.on('message', function (topic, message) {
                    try {
                      var event = JSON.parse(message.toString('utf8'));
                      onEvent(event);
                    } catch (error) {
                      // eslint-disable-next-line no-console
                      console.warn(topic, message, error);
                    }
                  });
                });

              case 4:
                return _context.abrupt("return", _context.sent);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }(),
    close: function () {
      var _close = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee2() {
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (isInitialized) {
                  _context2.next = 2;
                  break;
                }

                throw new Error(subscribeAdapterNotInitialized);

              case 2:
                isInitialized = false;
                client.end();
                client = undefined;

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function close() {
        return _close.apply(this, arguments);
      }

      return close;
    }(),
    subscribeToTopics: function () {
      var _subscribeToTopics = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee3(topics) {
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (isInitialized) {
                  _context3.next = 2;
                  break;
                }

                throw new Error(subscribeAdapterNotInitialized);

              case 2:
                _context3.next = 4;
                return Promise.all(topics.map(function (topic) {
                  return new Promise(function (resolve, reject) {
                    return client.subscribe(getMqttTopic(appId, topic), {
                      qos: qos
                    }, function (err) {
                      return err ? reject(err) : resolve();
                    });
                  });
                }));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function subscribeToTopics(_x) {
        return _subscribeToTopics.apply(this, arguments);
      }

      return subscribeToTopics;
    }(),
    unsubscribeFromTopics: function () {
      var _unsubscribeFromTopics = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee4(topics) {
        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (isInitialized) {
                  _context4.next = 2;
                  break;
                }

                throw new Error(subscribeAdapterNotInitialized);

              case 2:
                _context4.next = 4;
                return Promise.all(topics.map(function (topic) {
                  return new Promise(function (resolve, reject) {
                    return client.unsubscribe(getMqttTopic(appId, topic), function (err) {
                      return err ? reject(err) : resolve();
                    });
                  });
                }));

              case 4:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function unsubscribeFromTopics(_x2) {
        return _unsubscribeFromTopics.apply(this, arguments);
      }

      return unsubscribeFromTopics;
    }(),
    isConnected: function isConnected() {
      if (!isInitialized) {
        throw new Error(subscribeAdapterNotInitialized);
      }

      return client.connected;
    }
  };
};

createClientAdapter.adapterName = 'mqtt';
export default createClientAdapter;
//# sourceMappingURL=index.js.map